import { EquipmentSlot, BlockPermutation, ItemStack, system } from '@minecraft/server';
import { AutoSmeltRawOres, SmeltedConversions } from './libraries/constants';
import { afterEvents, beforeEvents, sleep } from './libraries/utils2';
import { DamageItem } from './libraries/Durability2'; 
import './oresplus_swords.js'
import './oresplus_loot.js'
import './armor.js'
afterEvents.itemUseOn.subscribe(({ source }) => DamageItem(source, source.equippable.getEquipmentSlot(EquipmentSlot.Mainhand)));
beforeEvents.playerBreakBlock.subscribe(async ({ player, block, dimension, itemStack: item }) => {
    if (!item?.getTags().includes('oresplus:infernal'))
        return;
    if (!(block.typeId in SmeltedConversions)) {
        await sleep();
        return DamageItem(player, player.equippable.getEquipmentSlot(EquipmentSlot.Mainhand));
        ;
    }
    const { location } = block;
    await sleep();
    const drops = dimension.getEntities({ type: 'minecraft:item', maxDistance: 1.9, location: block.location });
    if (!drops.length)
        return;
    for (const drop of drops) {
        const { itemStack: item } = drop.getComponent('item');
        const conversion = AutoSmeltRawOres[item.typeId] || SmeltedConversions[item.typeId];
        if (!conversion)
            return;
        drop.remove();
        dimension.spawnItem(new ItemStack(conversion), location);
    }
    dimension.playSound('random.fizz', location);
    await sleep(4);
    DamageItem(player, player.equippable.getEquipmentSlot(EquipmentSlot.Mainhand));
});

afterEvents.entityHurt.subscribe(({ hurtEntity, damageSource: { damagingEntity: player } }) => {
    if (!player?.isPlayer() || !hurtEntity.isValid())
        return;
    const equippable = player.equippable;
    const hand = equippable.getEquipment(EquipmentSlot.Mainhand);
    if (!hand?.getTags().includes('oresplus:infernal'))
        return;
    hurtEntity.setOnFire(8, true);
});

import AntiBurner from "./libraries/burn";
system.run(() => new AntiBurner(["pyrite_"]));
system.run(() => new AntiBurner(["netherite_"]));